import define from "../../define.js";
import { ApiError } from "../../error.js";
import { getUser } from "../../common/getters.js";
import { CallBlockings, Users } from "../../../../models/index.js";
import { HOUR } from "../../../../const.js";
import { getGroupActor } from "../../common/get-group-actor.js";
export const meta = {
    tags: [
        "account"
    ],
    limit: {
        duration: HOUR,
        max: 100
    },
    requireCredential: true,
    kind: "write:blocks",
    errors: {
        noSuchUser: {
            message: "No such user.",
            code: "NO_SUCH_USER",
            id: "84d4f8bd-c78f-4b64-a542-76daefbd2338"
        },
        blockeeIsYourself: {
            message: "Blockee is yourself.",
            code: "BLOCKEE_IS_YOURSELF",
            id: "8b347b91-c674-45af-8f4f-1fbbbcbd6f08"
        },
        notBlocking: {
            message: "You are not rejecting calls from that user.",
            code: "NOT_CALL_BLOCKING",
            id: "7bd363a2-278f-46f8-a03a-ee1220302a3c"
        },
        noSuchGroup: {
            message: "No such group.",
            code: "NO_SUCH_GROUP",
            id: "27f63aa2-58cc-418a-8e9b-83d13f46048f"
        }
    },
    res: {
        type: "object",
        optional: false,
        nullable: false,
        ref: "UserDetailedNotMe"
    }
};
export const paramDef = {
    type: "object",
    properties: {
        userId: {
            type: "string",
            format: "misskey:id"
        },
        groupId: {
            type: "string",
            format: "misskey:id",
            nullable: true
        }
    },
    required: [
        "userId"
    ]
};
export default define(meta, paramDef, async (ps, user)=>{
    const blocker = await Users.findOneByOrFail({
        id: user.id
    });
    const group = await getGroupActor(ps.groupId, user);
    if (ps.groupId != null && group == null) throw new ApiError(meta.errors.noSuchGroup);
    if (group == null && user.id === ps.userId) {
        throw new ApiError(meta.errors.blockeeIsYourself);
    }
    const blockee = await getUser(ps.userId).catch((e)=>{
        if (e.id === "15348ddd-432d-49c2-8a5a-8069753becff") throw new ApiError(meta.errors.noSuchUser);
        throw e;
    });
    const blocking = await CallBlockings.findOneBy({
        blockeeId: blockee.id,
        ...group ? {
            groupId: group.id
        } : {
            blockerId: blocker.id,
            groupId: null
        }
    });
    if (!blocking) {
        throw new ApiError(meta.errors.notBlocking);
    }
    await CallBlockings.delete(blocking.id);
    return await Users.pack(blockee.id, blocker, {
        detail: true
    });
});
